-- declaring local variables that will be used only inside map-functions.lua
--tileW, tileH, tileset, quads, tileTable

require 'items'
local bresenham = require 'bresenham'

quadInfo = {
  { '.', 0, 0 }, -- floor outside
  { ' ', 120, 180 }, --10,15 -> 120,180 DONE floor inside
  { '#', 12, 132 }, --1,11 -> 12,132 DONE wall
  { '<', 144, 36 }, -- 12,3 -> 144,36 staircase
  { '$', 48, 24 }, -- 4,2 coin money
  { '^', 60,0 }, -- test , 
  { '>', 168,36 }, --corner right side bottom 18/11
  { '+', 132,24 }, -- closed door 11,2 -> 121, 24
  { '/', 180,24}, --open dor 15,2 -> 180,24
  { '@', 0,48 },
  { '!', 12,24 }, --potion on 1,2 => 12,24
  { ')',108,24 },--weapon 9,2 => 108,24
  { 'c',36,48 }, --3,4 -> 
  { 'b',36,48 },
  { 'd',36,48 },
  { '=', 120, 180 },
  { '-', 144, 168 }, --12,14 -> 144,
  { "?",96,168 } --8,14 --> 
}

--newMap(12,12,'Alloy_curses_12x12.png',tileString,quadInfo)
--
dungeonlevel = 1



--function loadMap(path)
  --love.filesystem.load(path)() -- attention! extra parenthesis
function loadMap()

  	maps = {'mapstring.lua','mapstring2.lua'}

	math.randomseed( os.time() )
	math.random(); math.random(); math.random()

	testnumber = math.random(2)

	selectedmap = maps[testnumber]

	--if selectedmap = 

	love.filesystem.load(selectedmap)()
	
	maps[testnumber] = nil

	 enemies = nil
	 enemies = {}

	 items = nil
	 items = {}

	 item = {}

	 wallamount = 4

	tileTablevisited = {}

	 for i = 1, 50 do
    		tileTablevisited[i] = {}

    		for j = 1, 30 do
        		tileTablevisited[i][j] = 0 
    		end
	 end


	 monsterspawnrate = 3 + (dungeonlevel-1)*2

	 --generateEnemy()
  	for i=1,monsterspawnrate do	
		generateEnemy()
		table.insert(enemies,createEnemy())
	end

	
	timerbeginning = 100
	timerquotientbeginning = 100

	timer = timerbeginning - ((timerbeginning/timerquotientbeginning) * (dungeonlevel-1))

  	timerstart = timerbeginning - ((timerbeginning/timerquotientbeginning) * (dungeonlevel-1))

end

function newMap(tileWidth, tileHeight, tilesetPath, tileString, quadInfo)
  
  tileW = tileWidth
  tileH = tileHeight
  tileset = love.graphics.newImage(tilesetPath)


	 weaponamount = 0


  local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()
  
  quads = {}

  for _,info in ipairs(quadInfo) do
    -- info[1] = the character, info[2] = x, info[3] = y
    quads[info[1]] = love.graphics.newQuad(info[2], info[3], tileW, tileH, tilesetW, tilesetH)
  end
  
  tileTable = {}
  
  local width = #(tileString:match("[^\n]+"))

  for x = 1,width,1 do tileTable[x] = {} end

  local rowIndex,columnIndex = 1,1
  for row in tileString:gmatch("[^\n]+") do
    assert(#row == width, 'Map is not aligned: width of row ' .. tostring(rowIndex) .. ' should be ' .. tostring(width) .. ', but it is ' .. tostring(#row))
    columnIndex = 1
    for character in row:gmatch(".") do
      tileTable[columnIndex][rowIndex] = character



      if tileTable[columnIndex][rowIndex] == '?' and dungeonlevel > 1 then
	      tileTable[columnIndex][rowIndex] = ' '
	end

      -- add random items
	
	if tileTable[columnIndex][rowIndex] == " " and love.math.random(150) == 20 then
		--love.graphics.setColor(255,255,255)
		tileTable[columnIndex][rowIndex] = '$'
	end

	if tileTable[columnIndex][rowIndex] == ' ' and love.math.random(150) == 20 then

		tileTable[columnIndex][rowIndex] = "!"
	end

	if tileTable[columnIndex][rowIndex] == ' ' and love.math.random(1000) == 500 then
		tileTable[columnIndex][rowIndex] = "="
	end

	--[[if tileTable[columnIndex][rowIndex] == " " and love.math.random(1000) == 200 then
		tileTable[columnIndex][rowindex] = "^"
	end]]

	if tileTable[columnIndex][rowIndex] == " " and love.math.random(300) == 150 and weaponamount < 1 then
		tileTable[columnIndex][rowIndex] = ")"
		attackdmg = math.random(1,20)
		critchance = math.random(1,20)
		weaponamount = 1
	end

	--if tileTable[columnIndex][rowIndex] == ' ' and love.math.random
	
	--createitem()

	--[[if tileTable[columnIndex][rowIndex] == " " then

		tileTable[columnIndex][rowIndex] = item.character
		--createitem()
		--table.insert(items,createitem())
	end]]
	
	


	columnIndex = columnIndex + 1
	
	
      --love.graphics.setColor(255,255,255)
      --love.graphics.print(character,100,100)

    end
    rowIndex=rowIndex+1
  end

  	--[[for i,v in ipairs(items) do
			tileTable[columnIndex][rowIndex] = v.character
	end]]

end

function checkEnemy(columnIndex,rowIndex)
	if tileTable[columnIndex][rowIndex] ~= ' ' then
		return true
	end

	return false
end

function checkitem(columnIndex,rowIndex)
	if tileTable[columnIndex][rowIndex] ~= ' ' then
		return true
	end

	return false
end

function checkitems(dx,dy)

	x= 0

	--local addmessagetest = true
	--addmessage = true

	--[[if tileTable[playertilex+dx][playertiley+dy] == '$' then
		playertest.money = playertest.money + 1
		output.addMessage("You picked up a coin!")
		tileTable[playertilex][playertiley] = ' '
	end]]

	if tileTable[playertilex+dx][playertiley+dy] == "^" then
		playertest.hp = 0
	end

	if tileTable[playertilex+dx][playertiley+dy] == '$' then
		

		--[[if addmessagetest == true then
			output.addMessage("Press , to pick up a coin!")
		end]]

		--[[while addmessagetest == true do
			output.addMessage("Press , to pick up a coin!")
			addmessagetest = false
		end]]

		output.addMessage("On the floor lies a gold coin.")

		
		--tileTable[playertilex+dx][playertiley+dy] ~= '$'
	end



	if tileTable[playertilex+dx][playertiley+dy] == "=" then
		randomtilex = math.random(1,50)
		randomtiley = math.random(1,30)
	
		if tileTable[randomtilex][randomtiley] ~= ' ' then
			randomtilex = math.random(1,50)
			randomtiley = math.random(1,30)
		else 	
			tileTable[playertilex][playertiley] = '-'
			output.addMessage("You walked into a portal!")
			playertilex = randomtilex
			playertiley = randomtiley

			tileTable[playertilex][playertiley] = '-'
		end

	end



	if tileTable[playertilex+dx][playertiley+dy] == "!" then
		output.addMessage("You see here a potion!")
	end


	if tileTable[playertilex+dx][playertiley+dy] == '+' then
		tileTable[playertilex+dx][playertiley+dy] = '/'
	end

	if tileTable[playertilex+dx][playertiley+dy] == ')' then
		--tileTable[playertilex+dx][playertiley+dy] = ' '
		
		output.addMessage("On the floor lies a weapon with "..attackdmg.." attack damage and "..critchance.." % critical strike.")
	end

	addmessagetest = false
	
end

function removeitem()

	--if tileTable[playertilex][playertiley] ~= ' ' then


		if tileTable[playertilex][playertiley] == '$' then
			tileTable[playertilex][playertiley] = ' '
		end

		if tileTable[playertilex][playertiley] == '?' then
			tileTable[playertilex][playertiley] = ' '
		end

		if tileTable[playertilex][playertiley] == '!' then
			tileTable[playertilex][playertiley] = ' '
		end

		if tileTable[playertilex][playertiley] == ")" then
			tileTable[playertilex][playertiley] = " "
		end


	--end


end

function isitfloor()

	if tileTable[playertilex][playertiley] == ' ' then
		return false
	end

	return true

end

function changemap()

	if tileTable[playertilex][playertiley] == '<' then

		playertilex = 25
		playertiley = 15
		playertest.dungeonlevel = playertest.dungeonlevel + 1
		dungeonlevel = dungeonlevel + 1
		wallamount = 4
		loadMap()

		return dungeonlevel
	end
end
		

--[[function drawMap()

  	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0

		if light == true then

		for i=1,7,1 do
				if math.abs(columnIndex-playertilex) < i and math.abs(rowIndex - playertiley) < i then
					love.graphics.setColor(255,255,255,255/i)
					love.graphics.draw(tileset,quads[char],x,y)
				else 
					love.graphics.setColor(0,0,0)
					love.graphics.draw(tileset,quads[char],x,y)
				end
			end
		end

   	 end
  	end
end]]


function fieldofview()

	maprightx = 50
	mapleftx = 0
	mapupy = 0
	mapdowny = 35


	local rightcheck = bresenham.los(playertilex,playertiley,maprightx,playertiley,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		
		--lastpointrightx = checkx+1
		lastpointrightx = checkx+2
		lastpointrighty = checky

		return true
	end)


	--------------------------------------------------------------


	local leftcheck = bresenham.los(playertilex,playertiley,mapleftx,playertiley,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		--lastpointleftx = checkx-1
		lastpointleftx = checkx-2
		lastpointlefty = checky

		return true
	end)


	--------------------------------------------------------------

	local upcheck = bresenham.los(playertilex,playertiley,playertilex,mapupy,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointupx = checkx
		--lastpointupy = checky-1
		lastpointupy = checky-2

		return true
	end)


	--------------------------------------------------------------

	local downcheck = bresenham.los(playertilex,playertiley,playertilex,mapdowny,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointdownx = checkx
		--lastpointdowny = checky+1
		lastpointdowny = checky + 2

		return true
	end)


	--------------------------------------------------------------
	
	local uprightcheck = bresenham.los(playertilex,playertiley,maprightx,mapupy,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointuprightx = checkx + 2
		lastpointuprighty = checky - 2

		return true
	end)


	--------------------------------------------------------------
	
		
	local downleftcheck = bresenham.los(playertilex,playertiley,mapleftx,mapdowny,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointdownleftx = checkx - 2
		lastpointdownlefty = checky + 2

		return true
	end)


	--------------------------------------------------------------
	
		
	local downrightcheck = bresenham.los(playertilex,playertiley,maprightx,mapdowny,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointdownrightx = checkx + 2
		lastpointdownrighty = checky + 2

		return true
	end)


	--------------------------------------------------------------
	
	local upleftcheck = bresenham.los(playertilex,playertiley,mapleftx,mapupy,

	function(checkx,checky)
	
	
	if tileTable[checkx][checky] == "#" or tileTable[checkx][checky] == "+" then		
		return false
	end
		lastpointupleftx = checkx - 2
		lastpointuplefty = checky - 2

		return true
	end)


	--------------------------------------------------------------
	
	
	


	for columnIndex,column in ipairs(tileTable) do
    		for rowIndex,char in ipairs(column) do
      		local x,y = (columnIndex-1)*tileW+200, (rowIndex-1)*tileH+0
	
	--[[if columnIndex < lastpointrightx and columnIndex > playertilex and rowIndex == playertiley then
		love.graphics.setColor(255,0,0)
		love.graphics.draw(tileset,quads[char],x,y)

	elseif columnIndex > lastpointleftx and columnIndex < playertilex and rowIndex == playertiley then
		love.graphics.setColor(255,0,0)
		love.graphics.draw(tileset,quads[char],x,y)
	
	elseif rowIndex > lastpointupy and rowIndex < playertiley and columnIndex == playertilex then
		love.graphics.setColor(255,0,0)
		love.graphics.draw(tileset,quads[char],x,y)

	elseif rowIndex < lastpointdowny and rowIndex > playertiley and columnIndex == playertilex then
		love.graphics.setColor(255,0,0)
		love.graphics.draw(tileset,quads[char],x,y)

	else
		love.graphics.setColor(0,255,0)
		love.graphics.draw(tileset,quads[char],x,y)
	end]]

	if columnIndex > lastpointleftx and columnIndex < lastpointrightx and rowIndex < lastpointdowny and rowIndex > lastpointupy and rowIndex > lastpointuprighty and columnIndex < lastpointuprightx and columnIndex > lastpointdownleftx and rowIndex < lastpointdownlefty and columnIndex < lastpointdownrightx and rowIndex < lastpointdownrighty and columnIndex > lastpointupleftx and rowIndex > lastpointuplefty then
		--love.graphics.setColor(255,255,255)
		--love.graphics.draw(tileset,quads[char],x,y)


		if light == true then

		for i=1,7,1 do
				if math.abs(columnIndex-playertilex) < i and math.abs(rowIndex - playertiley) < i then
					love.graphics.setColor(255,255,255,255/i)
					love.graphics.draw(tileset,quads[char],x,y)
					tileTablevisited[columnIndex][rowIndex] = true
				else 
					--love.graphics.setColor(0,0,0)
					--love.graphics.draw(tileset,quads[char],x,y)
				end
			
		end

		end

		for i=1,50,1 do
			for j=30,1 do


		if tileTablevisited[i][j] == true then
			local x,y = (i-1)*12+200, (j-1)*12+0
			love.graphics.setColor(95,95,95)
			love.graphics.draw(tileset,quads[char],x,y)
		end
		end

		end


	else
		--love.graphics.setColor(255,0,0)
		--love.graphics.draw(tileset,quads[char],x,y)

	end

	

end

end

love.graphics.setColor(255,255,255)

end

function playercheck(dx,dy)


	if tileTable[playertilex][playertiley-1] == '#' then --UP
		love.graphics.setColor(255,0,0)
		--return false
		love.graphics.rectangle("fill",(playertilex-1)*12+200,(playertiley-2)*12,12,12)
	end
	if tileTable[playertilex][playertiley+1] == '#' then --DOWN
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-1)*12+200,playertiley*12,12,12)
	end

	if tileTable[playertilex+1][playertiley] == '#' then --RIGHT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",playertilex*12+200,12*(playertiley-1),12,12)
	end

	if tileTable[playertilex-1][playertiley] == '#' then --LEFT
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill",(playertilex-2)*12+200,(playertiley-1)*12,12,12)
	end

	if tileTable[playertilex+dx][playertiley+dy] == '#' then
		return false
	end

	for i,v in ipairs(enemies) do
		if playertilex+dx == v.x and playertiley + dy == v.y then
			--playerattackenemy()
			--
				--playertest = {}
				--
			math.randomseed( os.time() )
			math.random(); math.random(); math.random()

			local critcheckplayer = math.random(100)
			--output.addMessage(critcheckplayer) for debugging

			critplayer = false

			playerdamage = playertest.basedmg + playertest.weapondmg
			playercritchance = playertest.critchance + playertest.weaponcritchance

			if critcheckplayer < playercritchance + 1 then
				--playertest.basedmg = 2 * playertest.basedmg
				playerdamage = playerdamage * 2
				critplayer = true
			end
	
			v.hp = v.hp - playerdamage

			if critplayer == true then
				attackstyle = "critted"
			else
				attackstyle = "attacked"
			end

			--output.addMessage("You "..playertest.name.." "..attackstyle.." for: "..playertest.basedmg.." damage")
			
			--love.graphics.setColor(0,255,0)

			output.addMessage(playertest.name.." "..attackstyle.." the "..v.name.." for: "..playerdamage.." damage")

			--enemyattack()
			
			enemysideattack = false

			if v.hp <= v.minhp then

				output.addMessage("The "..v.name.." died!")

				table.remove(enemies,i)

			end

			if v.hp > v.minhp then

				enemydamage = v.basedmg


				--[[local critcheckenemy = math.random(100)

				critenemy = false

				if critcheckenemy < v.critchance + 1 then
					enemydmg = enemydmg * 2
					critenemy = true
				end]]

				--playertest.hp = playertest.hp - v.basedmg

				playertest.hp = playertest.hp - enemydamage


				--[[if playertest.basedmg > 20 then
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." critted for: "..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				else	
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." monster attacked you for:"..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				end]]

				if critenemy == true then

					attackstyle = "critted"
				else
					attackstyle = "attacked"
				end

				--for debugging  monster dmg etc remove later on just  display health loss and how much dmg u do

			
				--love.graphics.setColor(255,0,0)

				output.addMessage("The "..v.name.." "..attackstyle.." you for: "..enemydamage.." damage")

				--enemyattack == false
			end


			return false

		end	
			
	end

	return true

end

function enemyattack()

	for i,v in ipairs(enemies) do

		if enemysideattack == true then

		if math.abs(v.x - playertilex) <= 1 and math.abs(v.y - playertiley) <= 1 then


			if (math.abs(v.x-playertilex) ~= 1 and math.abs(v.y-playertiley) == 1) or (math.abs(v.x-playertilex) == 1 and math.abs(v.y-playertiley) ~= 1) then

			if v.hp > v.minhp then

				enemydamage = v.basedmg


				--[[local critcheckenemy = math.random(100)

				critenemy = false

				if critcheckenemy < v.critchance + 1 then
					enemydmg = enemydmg * 2
					critenemy = true
				end]]

				--playertest.hp = playertest.hp - v.basedmg

				playertest.hp = playertest.hp - enemydamage


				--[[if playertest.basedmg > 20 then
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." critted for: "..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				else	
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." monster attacked you for:"..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				end]]

				if critenemy == true then

					attackstyle = "critted"
				else
					attackstyle = "attacked"
				end

				--for debugging  monster dmg etc remove later on just  display health loss and how much dmg u do

			
				--love.graphics.setColor(255,0,0)

				output.addMessage("The "..v.name.." "..attackstyle.." you for: "..enemydamage.." damage")

				return

			end

			end
		end

		end

	end

end

function doorcheck(dx,dy)

	doorbreak = 0

	--[[if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) == 3 then
		output.addMessage("You opened a door!")
		return true
	elseif tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(3) ~= 3 then
		output.addMessage("The door is locked. Kick it in!")
		return false
	end

	if tileTable[playertilex + dx][playertiley + dy] ~= '+' then
		return true
	end]]

	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(4) == 2 then
		output.addMessage("You opened a door!")
		return true
	end
	if tileTable[playertilex+dx][playertiley+dy] == '+' and math.random(5) ~= 3 then
		doorbreak = 0
		if doorbreak == 0 then
			output.addMessage("The door is locked. Kick it in!")
			doorbreak = doorbreak + 1
		elseif doorbreak ~= 0 then
			output.addMessage("KABOOM!")
		end
		return false
	end
	
	if tileTable[playertilex+dx][playertiley+dy] ~= '+' then
		return true

	end


end


function walladd(dx,dy)

	if tileTable[playertilex+dx][playertiley+dy] == " " and wallamount ~= 0 then
		tileTable[playertilex+dx][playertiley+dy] = "#"
		playertest.walls = playertest.walls - 1
		wallamount = wallamount - 1
	end

	wallmode = false

	output.addMessage("You placed a wall.")

end

function playertileon()

	if tileTable[playertilex][playertiley] == ")" then
		output.addMessage("You picked up a weapon.")
		playertest.weapondmg = attackdmg
		playertest.weaponcritchance = critchance
	end

	if tileTable[playertilex][playertiley] == "?" then
		output.addMessage("You picked up a flashlight and turned it on.")
		light = true
	end

	if tileTable[playertilex][playertiley] == "$" then
		moneyamount = math.random(1,20)
		output.addMessage("You picked up "..moneyamount.." gold coins!")
		playertest.money = playertest.money + moneyamount
	end

	if tileTable[playertilex][playertiley] == "!" then
		playertest.hp = playertest.hp + math.random(1,20)
		output.addMessage("You picked up a potion!")
	end


end

--[[function additems()

	if tileTable[columnIndex][rowIndex] == "." and love.math.random(10) == 10 then
		tileTable[columnIndex][rowIndex] = "*"
	end

end]]

--[[function enemyattack()


			enemy.basedmg = 20
			enemy.critchance = 90
			enemy.hp = 60
			enemy.minhp = 0

			--[[if v.hp > v.minhp then

				enemydamage = v.basedmg


				local critcheckenemy = math.random(100)

				critenemy = false

				if critcheckenemy < v.critchance + 1 then
					enemydmg = enemydmg * 2
					critenemy = true
				end

				playertest.hp = playertest.hp - v.basedmg

				playertest.hp = playertest.hp - enemydamage


				if playertest.basedmg > 20 then
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." critted for: "..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				else	
					love.graphics.setColor(255,0,0)
					output.addMessage("The "..enemy.name.." monster attacked you for:"..enemy.basedmg.." damage.")
					love.graphics.setColor(255,255,255)
				end

				if critenemy == true then
					attackstyle = "critted"
				else
					attackstyle = "attacked"
				end

				--for debugging  monster dmg etc remove later on just  display health loss and how much dmg u do

			
				love.graphics.setColor(255,0,0)

				output.addMessage("The "..v.name.." "..attackstyle.." you for: "..enemydamage.." damage")

			end
end]]




